#!/usr/bin/perl

# comdirect.pl
# ------------
# 
# Kleines Perl-Skript zum Abruf des Kontostands bei der comdirect-Bank.
#
# Bentigt LWP und die SSL-Untersttzung (libcrypt-ssleay-perl) dafr!
#
# Um mit dem Session Management auf Nummer sicher zu gehen, ruft das Skript
# artig wie ein normaler Browser die Seiten einzeln hintereinander ab.
# (Das sind beim comdirect-Interface, wenn man die Redirects mitzaehlt,
# ungefaehr 8 Schritte. Deswegen ist es auch so langsam.)
#
# Das Skript meldet sich am Ende nicht ab, ich hatte aber beim Testen
# nie Probleme mit "Doppelanmeldungen" o.ae.
#
# Wer selber basten will, kann jederzeit ein "httpdump($response)" nach
# einem HTTP-Request einbauen, um zu sehen, was kam.
#
# USE AT YOUR OWN RISK!
#
# (c) Frederik Ramm <frederik@remote.org> 2002
# Version 1.0
# Aktuellste Version hier:
# http://www.remote.org/frederik/projects/software/banking/
# Public Domain.

use strict;
use HTTP::Request;
use LWP::UserAgent;

my $kto = 123456; # hier die eigene Kontonummer+Kennziffer
my $pin = 1234; # hier die pin

# --- STAGE 1 ---
#
# Die Startseite abrufen.
#
my $request = HTTP::Request->new("GET", "http://brokerage.comdirect.de/");
#printf("--> %s\n", $request->uri());
$request->push_header("User-agent" => "Mozilla/4.77 [en] (X11; U; Linux 2.4.17 i686)");
my $ua = LWP::UserAgent->new;
my $response = $ua->request($request);

# da gibt's normalerweise so ein Formular mit der naechsten Adresse

die "Cannot find 'jump' form at stage 1" unless 
    ($response->content =~ /(<form[^>]*name\s*=\s*["']?jump[^>]*)/si);
my $form = $1;

die "cannot understand form in stage 3(a)" 
    unless $form =~ /<form[^>]*method\s*=\s*["']?([a-z]+)["']?/si; 
my $method = $1;
$method=~y/a-z/A-Z/;

die "cannot understand form in stage 3(b)" 
    unless $form =~ /<form[^>]*action\s*=\s*(\S+)/si;
my $action = $1;
$action =~ y/"'>//d;
    

# --- STAGE 2 ---

$request = HTTP::Request->new($method, $action);
#printf("--> %s\n", $request->uri());
$request->push_header("User-agent" => "Mozilla/4.77 [en] (X11; U; Linux 2.4.17 i686)");
$response = $ua->request($request);

# das ist jetzt ein Frameset, von dem uns nur der "comhome"-Frame
# interessiert
#
die "Cannot find 'comhome' frame at stage 2" unless 
    ($response->content =~ /(<frame[^>]*name\s*=\s*["']?comhome[^>]*)/si);
my $frame = $1;

die "cannot find src in 'comhome' frame at stage 2" 
    unless $frame =~ /<frame[^>]*src\s*=\s*(\S+)/si;
my $src = $1;
$src =~ y/"'>//d;
$src = makeAbsolute($action, $src);

# --- STAGE 3 ---
#
# rekursives Frameset. Jetzt den "usecase"-Frame...
#
$request = HTTP::Request->new("GET", $src);
#printf("--> %s\n", $request->uri());
$request->push_header("User-agent" => "Mozilla/4.77 [en] (X11; U; Linux 2.4.17 i686)");
$response = $ua->request($request);

die "Cannot find 'usecase' frame at stage 3" unless 
    ($response->content =~ /(<frame[^>]*name\s*=\s*["']?usecase[^>]*)/si);
$frame = $1;

die "Cannot find src in 'usecase' frame at stage 3" 
    unless $frame =~ /<frame[^>]*src\s*=\s*(\S+)/si;
my $newsrc = $1;
$newsrc =~ y/"'>//d;
$newsrc = makeAbsolute($src, $newsrc);

# --- STAGE 4 ---
$request = HTTP::Request->new("GET", $newsrc);
#printf("--> %s\n", $request->uri());
$request->push_header("User-agent" => "Mozilla/4.77 [en] (X11; U; Linux 2.4.17 i686)");
$response = $ua->request($request);

# hier muss jetzt das Login-Formular kommen
#
die "Cannot find 'login' form at stage 4" unless 
    ($response->content =~ /(<form[^>]*name\s*=\s*["']?login[^>]*)/si);
$form = $1;

die "Cannot understand form at stage 4" 
    unless $form =~ /<form[^>]*method\s*=\s*["']?([a-z]+)["']?/si; 
$method = $1;
$method=~y/a-z/A-Z/;

die "cannot understand form at stage 4" 
    unless $form =~ /<form[^>]*action\s*=\s*(\S+)/si;
$action = $1;
$action =~ y/"'>//d;
    

# --- STAGE 5 ---
#
$action = makeAbsolute($newsrc, $action);
$request = HTTP::Request->new($method, $action);
$request->content("param1=$kto&param2=$pin");
$request->push_header("Content-type" => "application/x-www-form-urlencoded");
$request->push_header("User-agent" => "Mozilla/4.77 [en] (X11; U; Linux 2.4.17 i686)");
#printf("x --> %s\n", $request->uri());
$response = $ua->request($request);

# Hier kommt jetzt ein "unechter" Redirect mit einem onLoad-Attribut
# im Body-Tag...
#
die("cannot find onLoad attribute at stage 5") unless
    ($response->content =~ /onLoad\s*=\s*["']?top\.comhome\.location=["']?([^'"]+)/si);
my $onload = $1;
my $loc = makeAbsolute($action,$onload);

# --- STAGE 6 ---
$request = HTTP::Request->new("GET", $loc);
#printf("y --> %s\n", $request->uri());
$request->push_header("User-agent" => "Mozilla/4.77 [en] (X11; U; Linux 2.4.17 i686)");
$response = $ua->request($request);

# wieder ein usecase-Frame...
#
die "Cannot find 'usecase' frame at stage 2" unless 
    ($response->content =~ /(<frame[^>]*name\s*=\s*["']?usecase[^>]*)/si);
$frame = $1;

die "cannot find src in 'usecase' frame at stage 2" 
    unless $frame =~ /<frame[^>]*src\s*=\s*(\S+)/si;
$newsrc = $1;
$newsrc =~ y/"'>//d;
$newsrc = makeAbsolute($loc, $newsrc);

# --- STAGE 7 ---
$request = HTTP::Request->new("GET", $newsrc);
#printf("--> %s\n", $request->uri());
$request->push_header("User-agent" => "Mozilla/4.77 [en] (X11; U; Linux 2.4.17 i686)");
$response = $ua->request($request);

# jetzt endlich die Seite, die uns interessiert:
#
die "Cannot find 'Kontoart' in overview" unless
    ($response->content =~ /(<table.*?Kontoart.*<\/table)/si);
my $res = $1;
my $copy=0;

# und <tr>-Elemente ansehen
while($res =~ /<tr(.*?)<\/tr>(.*)/si)
{
    $res = $2;
    my $tr = $1;
    my @line;
    while ($tr =~ /(<td.*?<\/td>)(.*)/si)
    {
        $tr=$2;
        my $td=$1;
        $td =~ s/<p[^<]*>/ /isg;
        $td =~ s/<br[^<]*>/ /isg;
        $td =~ s/<[^<]+>//g;
        $td =~ s/\s+/ /g;
        $td =~ /^\s*(.*?)\s*$/;
        push(@line, $1) unless ($1 eq "");
    }
    my $text = join(" / ", @line);
    $copy = 1 if ($text =~ /Kontoart/i);
    print "$text\n" if ($copy);
    last if ($text =~/Gesamt/i);
}
die "no lines found" unless ($copy);

# gibt den absoluten URL zurck, der sich ergibt, wenn man das
# 2. Argument mit BASE des 1. evaluiert
sub makeAbsolute
{
    my ($loc, $newl) = @_;
    if ($newl =~ /^http/i)
    {
        $loc=$newl;
    }
    elsif ($newl =~ /^\//)
    {
        $loc =~ /^(.*:\/\/[^\/]*)/;
        $loc = $1 . $newl;
    }
    else
    {
        $loc =~ /(.*\/)(.*)/;
        $loc = $1 if ($2 ne "");
        while($newl =~ /^\.\.\/(.*)/)
        {
            $newl = $1;
            $loc =~ /^(.*)(\/(.*))?$/;
            $loc = $1;
        }
        $loc .= "/".$newl;
    }
    return $loc;
}


sub httpdump
{
    my ($response) = @_;
    foreach my $key(keys(%{$response->headers}))
    {
        printf("%s=%s\n", $key,$response->headers->{$key});
    }
    print $response->content;
    print "\n";
}
